package net.bakingpowder.mDNSrelay.Server;

import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.MulticastSocket;
import java.net.Socket;
import java.net.UnknownHostException;
import java.io.IOException;
import java.io.OutputStream;

public class RecieveConnectControl implements Runnable {
	private Socket srcSocket, destSocket;
	private OutputStream srcOut;

	final static String MDNS_GROUP = "224.0.0.251";
	final static String MDNS_GROUP_IPV6 = "FF02::FB";
	final static int MDNS_PORT = 5353;
	final static int BUFFER_SIZE = 1024;

	MulticastSocket ms = null;
	InetAddress iams = null;

	byte[] buffer = new byte[BUFFER_SIZE];

	public RecieveConnectControl(Socket ss) {
		srcSocket = ss;
		try {
			ms = new MulticastSocket(MDNS_PORT);
			iams = InetAddress.getByName(MDNS_GROUP);
			ms.joinGroup(iams);
			srcOut = ss.getOutputStream();

		} catch (UnknownHostException e) {
			System.out.println("I can't get host address by name");
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	public void run() {
		while (true) {
			try {

				DatagramPacket dp = new DatagramPacket(buffer, buffer.length);
				ms.receive(dp);
//				if (ms.getTimeToLive() >= 253) {
					srcOut.write(buffer);
//				}

			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}